%define release 8mdk
%define date 2004_04_01
#%define _unpackaged_files_terminate_build 0

Summary: Linux Hotplug Scripts
Name: hotplug
Version: %{date}
Release: %{release}
Group: System/Configuration/Hardware
License: GPL
Url: http://linux-hotplug.sourceforge.net/
# Generated from cvs.
Source0: ftp://ftp.kernel.org/pub/linux/utils/kernel/hotplug/%name-%version.tar.bz2
Source1: http://www.linuxalpha.compaq.com/pcihpd/files/cpqphpd_gui-0.1.2.tar.bz2
Source2: http://www.linuxalpha.compaq.com/pcihpd/files/hpioctl.tar.bz2
Source3: cpqphpd_ioctl.h
Source4: hotplug.sysconfig

# We don't want hotplug to initialize the USB core modules, but we
# want to synthesize boot events
# Patch0: hotplug-2001_04_24-nousbinit.patch.bz2

# Add support for wireless devices
#Patch1: hotplug-2001_09_19-wireless2.patch.bz2

# don't call usbmodules in hotplug.funtions for usb
#Patch2:  hotplug-2002_01_14-no-usbmodules.patch.bz2

# We don't include initscript, don't reference it in the man page
Patch4: hotplug-2003_05_01-initfile.patch.bz2

#ifup fix.
Patch7: hotplug-2004_04_01-ifup-fix.patch.bz2

#scsimon and 2.4 compat
Patch8: hotplug-2004_03_29-scsimon.patch.bz2

# mdkize usb.rc until PCI coldplpug is available
Patch12: hotplug-2004_03_29-mdk_usb_rc.patch.bz2

# kernel 2.6 USB coldplug support
Patch13: hotplug-2004_03_29-usb.rc-coldplug26.patch.bz2

# conditional cold plug in /etc/init.d/hotplug
Patch14: hotplug-2003_08_05-sysconfig_rc.patch.bz2

# blacklist audio module, use snd-usb-audio instead
Patch15: hotplug-2004_03_29-blacklist-audio.patch.bz2

# don't call stop action
Patch16: hotplug-2004_01_05-shutdown.patch.bz2

# update-usb.usermap script
Patch17: hotplug-2004_03_29-update-usb-usermap.patch.bz2

# fix usb.rc to load on the right class field
Patch18: hotplug-2004_04_01-usb-cold-boot.patch.bz2

# fix path to load firmware
Patch19: hotplug-2004_04_01-firmware-path.patch.bz2

# don't use wc
Patch20: hotplug-2004_04_01-wc.patch.bz2

BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	gcc
BuildRequires:	gettext
BuildRequires:	gnome-libs-devel
BuildRequires:	texinfo
BuildRequires:	xpm-devel

BuildRoot: %{_tmppath}/%{name}-root
Prereq:	chkconfig
Obsoletes: usbd
Provides: usbd
Requires: usbutils
Requires: ifplugd
Requires: ethtool
Requires: wireless-tools

%description
This package contains the scripts necessary for hotplug Linux support,
and lets you plug in new devices and use them immediately.
Initially, it includes support for USB and PCI (Cardbus) devices, 
and can automatically configure network interfaces.

%package gtk
Summary: GTK control interface for Hotplug PCI
Group: System/Configuration/Hardware

%description gtk
This is the GTK interface for the Compaq PCI hotplug controller

%prep
%setup -q -a 1 -a 2

#%patch4 -p1 -b .initfile
%patch7 -p1 -b .ifup-fix
%patch8 -p1 -b .scsimon
%patch12 -p1 -b .mdk_usb_rc
%patch13 -p1 -b .coldplug26
%patch14 -p1 -b .sysconfig_rc
%patch15 -p1 -b .audio
%patch16 -p1 -b .shutdown
%patch17 -p1 -b .update-usb-usermap
%patch18 -p1 -b .usb-cold-boot
%patch19 -p1 -b .firmware-path
%patch20 -p1 -b .wc

%build

##%%make -C fxload/ CFLAGS="%optflags"

pushd cpqphpd_gui
%configure
%make
pushd ../usr/src/hpioctl
cp -fv %{SOURCE3}  .
%make
popd
popd

%install
rm -rf $RPM_BUILD_ROOT

# install the main hotplug script
make prefix=$RPM_BUILD_ROOT install

# install files provide by our patches
install -m 644 etc/hotplug/usb/usb-storage $RPM_BUILD_ROOT/etc/hotplug/usb
install -d $RPM_BUILD_ROOT/etc/hotplug/ieee1394
install -m 644 etc/hotplug/ieee1394/sbp2 $RPM_BUILD_ROOT/etc/hotplug/ieee1394

# hotplug PCI program
mkdir -p $RPM_BUILD_ROOT/usr/sbin
cp usr/src/hpioctl/iotest $RPM_BUILD_ROOT/usr/sbin/hotplugctl

# install /etc/sysconfig/hotplug
install -d $RPM_BUILD_ROOT/etc/sysconfig
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/etc/sysconfig/hotplug

# update-usb.usermap
mkdir -p $RPM_BUILD_ROOT/lib/hotplug $RPM_BUILD_ROOT/usr/lib
install -m 755 debian/update-usb.usermap $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
install -m 644 debian/update-usb.usermap.8 $RPM_BUILD_ROOT%{_mandir}/man8

pushd cpqphpd_gui
make DESTDIR=$RPM_BUILD_ROOT install
popd

cd $RPM_BUILD_ROOT/usr/lib
ln -s ../../lib/hotplug hotplug
cd -

%clean
rm -fr %buildroot

%pre
if [ ! -L /usr/lib/hotplug ]; then
	echo "Moving /usr/lib/hotplug to /lib/hotplug"
	mkdir -p /lib/hotplug/
	mv /usr/lib/hotplug/* /lib/hotplug/
	rmdir /usr/lib/hotplug
	cd /usr/lib/
	ln -s ../../lib/hotplug hotplug
fi

%post
/usr/sbin/update-usb.usermap || :

%files
%defattr(-,root,root)
/sbin/*
/usr/sbin/*

%dir /etc/hotplug.d
%dir /etc/hotplug.d/default
/etc/hotplug.d/default/default.hotplug

/usr/lib/hotplug
%dir /lib/hotplug
%dir /etc/hotplug
%dir /etc/hotplug/usb
%dir /etc/hotplug/pci
%dir /etc/hotplug/ieee1394
%config(noreplace) /etc/hotplug/blacklist
%config(noreplace) /etc/hotplug/hotplug.functions
%config(noreplace) /etc/hotplug/usb.distmap
%config(noreplace) /etc/hotplug/usb.handmap
%ghost /etc/hotplug/usb.usermap
%defattr(0755,root,root)
%config(noreplace) /etc/hotplug/dasd.agent
%config(noreplace) /etc/hotplug/firmware.agent
%config(noreplace) /etc/hotplug/ieee1394.agent
%config(noreplace) /etc/hotplug/ieee1394/sbp2
%config(noreplace) /etc/hotplug/input.agent
%config(noreplace) /etc/hotplug/input.rc
%config(noreplace) /etc/hotplug/net.agent
%config(noreplace) /etc/hotplug/pci.agent
%config(noreplace) /etc/hotplug/pci.rc
%config(noreplace) /etc/hotplug/scsi.agent
%config(noreplace) /etc/hotplug/tape.agent
%config(noreplace) /etc/hotplug/usb.agent
%config(noreplace) /etc/hotplug/usb.rc
%config(noreplace) /etc/hotplug/usb/usb-storage

%config(noreplace) /etc/init.d/hotplug
%config(noreplace) /etc/sysconfig/hotplug

%dir /var/run/usb
%{_mandir}/*/*
%doc README ChangeLog

%files gtk
%defattr(-,root,root)
/usr/bin/cpqphpgui
/usr/share/pixmaps/cpqphpgui

%changelog
* Fri Oct  8 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_04_01-8mdk
- patch20: don't use wc in usb.rc
- fix update scriptlet (bug #11890)

* Fri Oct 01 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 2004_04_01-7mdk
- patch 15: blacklist snd-usb-audio too

* Tue Sep 14 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_04_01-6mdk
- lookup firmware in /lib/hotplug to be able to have a separated /usr

* Thu Aug 26 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_04_01-5mdk
- fix cold boot for usb

* Tue Aug  3 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_04_01-4mdk
- fix eagle-usb check in hotplug script (Olivier Blin)

* Tue Aug 03 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 2004_04_01-3mdk
- make it rpmbuildupdate aware

* Fri Jul 30 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_04_01-2mdk
- net.agent: pcmcia cards need now to be configured with ONBOOT=yes and they
will be started by the network service.
- net.agent: do not create an automatic config file for eagle-usb interfaces

* Fri Jul 30 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_04_01-1mdk
- removed patch10 (merged upstream)
- adapted patch7 (ifup)
- 2004_04_01

* Wed Mar 31 2004 Nicolas Planel <nplanel@mandrakesoft.com> 2004_03_29-1mdk
- 2004_03_29.
- rework patch mdk_usb_rc (patch 12).
- add missing update-usb.usermap script (patch 17).

* Thu Mar 25 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_01_05-5mdk
- don't call stop action (anthill #415, bugs #9066, #8693)

* Thu Mar 11 2004 Nicolas Planel <nplanel@mandrakesoft.com> 2004_01_05-4mdk
- add audio module in blacklist.

* Thu Feb 26 2004 Nicolas Planel <nplanel@mandrakesoft.com> 2004_01_05-3mdk
- wait scsi type in scsi.agent with timeout (20 sec)

* Wed Feb 18 2004 Frederic Lepied <flepied@mandrakesoft.com> 2004_01_05-2mdk
- drop patch15 (this is done by spec-helper)
- net.agent: support ath and wlan card (patch 7)

* Tue Jan 06 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 2004_01_05-1mdk
- new release

* Fri Jan  2 2004  Olivier Blin <blino@mandrake.org> 2003_08_05-2mdk
- fix broken restart and status in initscript from Patch14
  (do not start hotplug instead), with advice from Michael Scherer
- use gprintf instead of echo in initscript (Patch15)
  (it was already in the binary rpm, but not in the source rpm)

* Mon Nov 17 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 2003_08_05-1mdk
- merge andrey work

* Sat Nov  1 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_08_05-0.4bor
- simplify patch12; make it reentrant; ensure usblp is unloaded on 2.6
- remove all calls to `action' - currently it is already run under
  initlog so all escapes get logged that has bad effects when browsing
  log files

* Sat Nov  1 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_08_05-0.3bor
- really fix patch 14

* Sat Nov  1 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_08_05-0.2bor
- update from CVS
- remove patch3 - integrated upstream
- remove patch5 - different version upstream
- remove patch6 - integrated upstream
- remove patch11 - integrated upstream
- remove patch15 - integrated upstream
- fix patch14
- update patch7 - note that now net.agent exports IN_HOTPLUG for interface
  scripts to use
- disable patch4 - we do include initscripts now
- do not forget to package new agents

* Wed Aug  6 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_08_05-0.1bor
- new version
- rediff patch5
- remove patch9 - fixed upstream
- patch15 - make sure hex values in sysfs for USB are interpreted as
  hex and not as decimal

* Sat Aug  2 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_05_01-0.4bor
- default USB coldplug to yes, else likely no one would ever test it

* Fri Aug  1 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_05_01-0.3bor
- input.agent fixes
- add input.rc
- install /etc/init.d/hotplug, I am going to use it
- source4 - /etc/sysconfig/hotplug, controls which susbsystems are
  initialized by init.d/hotplug
- patch14 - support conditional start of cold plug scripts in init script
  defaulting to off

* Thu Jul 31 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_05_01-0.2bor
- patch13 - support USB coldplug on 2.6. Module lister (a.k.a. usbmodules)
  is disabled on 2.6 so it did nothing. Pass sysfs devpath on 2.6 so usb.agent
  can extract needed info; walk /sys/bus/usb instead of /proc/bus/usb

* Thu Jul 31 2003 Andrey Borzenkov <arvidjaar@mail.ru> 2003_05_01-0.1bor
- new version
- rediff patch4
- rediff patch5
- redone patch8 - 2.4 and 2.6 compatibility
- use make install to install hotplug
- disable patch2 - it is likely no more needed
- patch9 - 2.5 -> 2.6 in all places (sans comments)
- disable patch1 - it is removed by patch7 anyway; rediff patch7
- patch10 - fix quoting in hotplug.functions
- patch11 - INPUT susbsytem support (requires updated module-init-tools)
- disable patch0 - we DO want start USB now
- patch12 - mdkize usb.rc

* Thu Mar 06 2003 Nicolas Planel <nplanel@mandrakesoft.com> 2002_04_01-8mdk
- Fix script exec

* Thu Mar 06 2003 Nicolas Planel <nplanel@mandrakesoft.com> 2002_04_01-7mdk
- add scsi.agent (recive scsi event, usefull with usb-storage)
  load sd_mod,st,sr_mod,... automaticaly
- add script in ieee1394/spb2 and usb/usb-storage (load scsimon)

* Tue Feb 18 2003 Frederic Lepied <flepied@mandrakesoft.com> 2002_04_01-6mdk
- net.agent: create a default config file for an ethernet device if it
doesn't exist.

* Wed Feb 12 2003 Frederic Lepied <flepied@mandrakesoft.com> 2002_04_01-5mdk
- use IFPLUGD_ARGS from /etc/sysconfig/network like the network service in
net.agent.

* Sun Feb  9 2003 Frederic Lepied <flepied@mandrakesoft.com> 2002_04_01-4mdk
- corrected net.agent to conform to the network service (bug #1453)

* Tue Jan 21 2003 Frederic Lepied <flepied@mandrakesoft.com> 2002_04_01-3mdk
- use ifplugd in network script

* Tue Aug 13 2002 Frederic Lepied <flepied@mandrakesoft.com> 2002_04_01-2mdk
- use the debian way to update usb.usermap (via update-usb.usermap)

* Tue Aug 13 2002 Frederic Lepied <flepied@mandrakesoft.com> 2002_04_01-1mdk
- 2002_04_01 version

* Wed Mar 20 2002 David BAUDENS <baudens@mandrakesoft.com> 2002_01_14-5mdk
- Clean after build

* Mon Mar 11 2002 Frederic Lepied <flepied@mandrakesoft.com> 2002_01_14-4mdk
- don't call usbmodules in hotplug.funtions for usb
- remove calls to updfstab

* Thu Feb 21 2002 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2002_01_14-3mdk
- Get a file description when invoking ifup in net.agent fix
  removal/insert of pcmcia cards.

* Sat Jan 19 2002 Stefan van der Eijk <stefan@eijk.nu> 2002_01_14-2mdk
- BuildRequires

* Wed Jan 16 2002 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2002_01_14-1mdk
- Requires usbutils.
- Redo filelist.
- Add hotplug-gtk package (Compaq Hotplug Graphical viewver).
- Merge RH patches.
- Upgrade to 2002_01_14.

* Mon Sep 17 2001 Frederic Lepied <flepied@mandrakesoft.com> 2001_06_12-8mdk
- added ieee1934.agent from cvs (Chmouel)

* Fri Sep 14 2001 Frederic Lepied <flepied@mandrakesoft.com> 2001_06_12-7mdk
- storage handling is handled by dynamic now.

* Thu Sep  6 2001 Frederic Lepied <flepied@mandrakesoft.com> 2001_06_12-6mdk
- fix for wacom module load

* Sat Sep  1 2001 Frederic Lepied <flepied@mandrakesoft.com> 2001_06_12-5mdk
- updated patch1 for wireless devices
- don't install patch backup files

* Thu Aug 30 2001 Frederic Lepied <flepied@mandrakesoft.com> 2001_06_12-4mdk
- Run ifdown on interface unregistration (kill stale DHCP clients)
- own /etc/hotplug

* Wed Jul 11 2001 Frederic Lepied <flepied@mandrakesoft.com> 2001_06_12-3mdk
- added a call to updfstab when usb-storage is loaded

* Wed Jun 13 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2001_06_12-2mdk
- noreplace /etc/ files.
- Update description.
- ifdown net when unregister net card.

* Tue Jun 12 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2001_06_12-1mdk
- First mandrake release (generated from cvs, spec file inspired from rh).

